angular.module('services', [])
    .factory('TipsService', ['$ionicPopup','$timeout','$ionicLoading','$rootScope',function($ionicPopup,$ionicLoading,$rootScope) {
        return {
            showTips: function(text) {
                $ionicPopup.show({
                    template: '<div style="text-align: center">'+text+'</div>',
                    title: '提醒',
                    subTitle: '',
                    buttons: [
                        { text: '确定',
                            type: 'button-positive'
                        }
                    ]
                });
            },
            showAlert: function(text) {
                $ionicPopup.show({
                    template: '<div style="text-align: center">'+text+'</div>',
                    title: '提醒',
                    subTitle: '',
                    buttons: [
                        { text: '确定',
                            type: 'button-positive'
                        }
                    ]
                });
            },
            showConfirm : function(title,text,sure_cb,cal_cb) { 
                var confirmPopup = $ionicPopup.confirm({ 
                    title: title, 
                    template: '<div style="text-align: center">'+text+'</div>', 
                    buttons: [ 
                    { 
                    text: '<b>Cancel</b>', 
                    type: 'button-stable', 
                    onTap: function(e) { 
                    return 'camcel'; 
                    } 
                    }, 
                    { 
                    text: '<b>OK</b>', 
                    type: 'button-positive', 
                    onTap: function(e) { 
                    return 'ok'; 
                    } 
                    } 
                    ] 
                }); 
                confirmPopup.then(function(res) { 
                if(res=='ok') { 
                sure_cb && sure_cb(); 
                } else { 
                cal_cb && cal_cb(); 
                } 
                }); 
                $timeout(function() { 
                confirmPopup.close(); //close the popup after 3 seconds for some reason 
                }, 3000); 
            },
            showLoading:function(text){
                $rootScope['ncConfig']={};
                $rootScope['ncConfig']['showLoading']=true;
            },
            hideLoading:function(){
                $rootScope['ncConfig']={};
                $rootScope['ncConfig']['showLoading']=false;
            }
        };
    }]).factory('AjaxService', ['$http','$rootScope','commonService',
    function ($http,$rootScope,commonService) {
        'use strict';
        var times = 10000;
        var userinfo = {};
        var setToken = function(uid,token){
            userinfo['supervisor_id'] = uid;
            userinfo['token'] = token;
        };
        var ajaxRequest = function(httpUrl,method, datas) {
            if(method=='GET'){
                for(var i in datas){
                    httpUrl+="&"+i+"="+datas[i];
                }
            }
            jsdebug(datas);

            var param = function(obj) {
                var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
                for (name in obj) {
                    value = obj[name];
                    if (value instanceof Array) {
                        for (i = 0; i < value.length; ++i) {
                            subValue = value[i];
                            fullSubName = name + '[' + i + ']';
                            innerObj = {};
                            innerObj[fullSubName] = subValue;
                            query += param(innerObj) + '&';
                        }
                    } else if (value instanceof Object) {
                        for (subName in value) {
                            subValue = value[subName];
                            fullSubName = name + '[' + subName + ']';
                            innerObj = {};
                            innerObj[fullSubName] = subValue;
                            query += param(innerObj) + '&';
                        }
                    } else if (value !== undefined && value !== null)
                        query += encodeURIComponent(name) + '=' + encodeURIComponent(value)
                        + '&';
                }
                return query.length ? query.substr(0, query.length - 1) : query;
            };

            return $http({
                headers : {'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'},
                method: method,
                url: httpUrl,
                data:datas,
                timeout: times,
                transformRequest:function(obj){
                    return param(obj);
                }
            })
        };
        // 返回带有一个$ajax函数的服务对象
        return {
            setToken:setToken,
            /**
             * @param httpUrl 请求地址
             * @param datas 数据
             */
            $ajax: function(httpUrl,method, datas) {
                $rootScope['ncConfig']={};
                $rootScope['ncConfig']['showLoading']=true;
                var _tmpUrl = httpUrl;
                for(var i in userinfo){
                    if(_tmpUrl.indexOf("?")!=-1){
                        _tmpUrl+="&"+i+"="+userinfo[i];
                    }else{
                        _tmpUrl+="?"+i+"="+userinfo[i];
                    }
                }
                return ajaxRequest(_tmpUrl,method, datas);
            },
            setTimes:function(time){
                if(time != ""){
                    times = time;
                }
            }
        };
    }]).factory('commonService', ['$window','$rootScope',
    function ($window,$rootScope) {
        // 返回带有一个$ajax函数的服务对象
        return {
            //getCommunity_id:function(){
            //    var id = localStorage.getItem("shequ_id");
            //    if(typeof(id)=='undefined'||id==null||id==''){
            //        return 0;
            //    }else{
            //        return id;
            //    }
            //},
            //getCommunity_name:function(){
            //    var name = localStorage.getItem("shequ_name");
            //    if(typeof(name)=='undefined'||name==null||name==''){
            //        return '';
            //    }else{
            //        return name;
            //    }
            //},
            //setCommunity:function(name,id){
            //    localStorage.setItem('shequ_id',id);
            //    localStorage.setItem('shequ_name',name);
            //    $rootScope.cur_shequ_info.id = id;
            //    $rootScope.cur_shequ_info.name = name;
            //},
            setUserInfo:function(user){
                var tmp = '';
                if(user!='' && user!=null && 'id' in user){
                    tmp = angular.toJson(user);
                    if(window.jPushReady==true) {
                        window.plugins.jPushPlugin.setAlias('os_' + window.mode + '_' + user.id);
                    }
                    console.log('os_'+window.mode+'_'+user.id);
                }else{
                    if(window.jPushReady==true) {
                        window.plugins.jPushPlugin.setAlias('');
                        console.log('tologout');
                    }
                }
                localStorage.setItem("user",tmp);
            },
            getUserInfo:function(){
                var tmp = localStorage.getItem("user");
                console.log('**************');
                console.log(tmp);
                console.log('**************');
                if(tmp!='' && tmp!=null){
                    var tmp1 = angular.fromJson(tmp);
                    if('id' in tmp1){
                        if(window.jPushReady==true){
                            window.plugins.jPushPlugin.setAlias('os_'+window.mode+'_'+tmp1.id);
                        }
                        return tmp1;
                    }
                    if(window.jPushReady==true) {
                        window.plugins.jPushPlugin.setAlias('');
                    }
                    return false;
                }
                if(window.jPushReady==true) {
                    window.plugins.jPushPlugin.setAlias('');
                }
                return false;
            },
            setVibration:function(value){
                var tmp = 'true';
                if(value==''||value=='no'){
                    tmp = 'false';
                }
                localStorage.setItem("vibration",value);
            },
            getVibration:function(){
                var tmp = localStorage.getItem("vibration");
                if(tmp==null || tmp==''||tmp=='no'){
                    return false;
                }
                return true;
            }
        };
    }]);
